再談PHP錯誤與異常處理

請一定要註意,沒有特殊說明:本例 PHP Version < 7
說起PHP異常處理,大傢首先會想到try-catch,那好,我們先看一段程序吧:有一個test.php文件,有一段簡單的PHP程序,內容如下,然後命令行執行:php test.php

1 <?php
2     $num = 0;
3     try {
4         echo 1/$num;5
6     } catch (Exception $e){
7         echo $e->getMessage();
8     }
9 ?>

我的問題是:這段程序能正確的捕捉到除0的錯誤信息嗎?
如果你回答能,那你就把這篇文章看完吧!應該能學點東西。

本文章分5個部分介紹我的異常處理的理解:

一、異常與錯誤的概述

PHP中什麼是異常

程序在運行中出現不符合預期的情況,允許發生(你也不想讓他出現不正常的情況)但他是一種不正常的情況,按照我們的正常邏輯本不該出的錯誤,但仍然會出現的錯誤,屬於邏輯和業務流程的錯誤,而不是編譯或者語法上的錯誤。

PHP中什麼是錯誤

屬於php腳本自身的問題,大部分情況是由錯誤的語法,服務器環境導致,使得編譯器無法通過檢查,甚至無法運行的情況。warning、notice都是錯誤,隻是他們的級別不同而已,並且錯誤是不能被try-catch捕獲的。

上面的說法是有前提條件的

在PHP中,因為在其他語言中就不能這樣下結論瞭,也就是說異常和錯誤的說法在不同的語言有不同的說法。在PHP中任何自身的錯誤或者是非正常的代碼都會當做錯誤對待,並不會以異常的形式拋出,但是也有一些情況會當做異常和錯誤同時拋出(據說是,我沒有找到合適的例子)。也就是說,你想在數據庫連接失敗的時候自動捕獲異常是行不通的,因為這就不是異常,是錯誤。但是在java中就不一樣瞭,他會把很多和預期不一致的行為當做異常來進行捕獲。

PHP異常處理很雞肋?

在上面的分析中我們可以看出,PHP並不能主動的拋出異常,但是你可以手動拋出異常,這就很無語瞭,如果你知道哪裡會出問題,你添加if else解決不就行瞭嗎,為啥還要手動拋出異常,既然能手動拋出就證明這個不是異常,而是意料之中。以我的理解,這就是PHP異常處理雞肋的地方(不一定對啊)。所以PHP的異常機制不是那麼的完美,但是使用過框架的同學都知道有這個情況:你在框架中直接寫開頭那段php“自動”捕獲異常的代碼是可以的,這是為什麼?看過源碼的同學都知道框架中都會涉及三個函數:register_shutdown_function,set_error_handler,set_exception_handler後面我會重點講解著三個黑科技,通過這幾個函數我們可以實現PHP假自動捕獲異常和錯誤。

二、ERROR的級別

隻有熟悉錯誤級別才能對錯誤捕捉有更好的認識。 ERROR有不同的錯誤級別,我之前的一篇文章中有寫到:http://www.cnblogs.com/zyf-zhaoyafei/p/3649434.html
下面我再總結性的給出這幾類錯誤級別:

Fatal Error:致命錯誤(腳本終止運行)
        E_ERROR         // 致命的運行錯誤,錯誤無法恢復,暫停執行腳本
        E_CORE_ERROR    // PHP啟動時初始化過程中的致命錯誤
        E_COMPILE_ERROR // 編譯時致命性錯,就像由Zend腳本引擎生成瞭一個E_ERROR
        E_USER_ERROR    // 自定義錯誤消息。像用PHP函數trigger_error(錯誤類型設置為:E_USER_ERROR)

    Parse Error:編譯時解析錯誤,語法錯誤(腳本終止運行)
        E_PARSE  //編譯時的語法解析錯誤

    Warning Error:警告錯誤(僅給出提示信息,腳本不終止運行)
        E_WARNING         // 運行時警告 (非致命錯誤)。
        E_CORE_WARNING    // PHP初始化啟動過程中發生的警告 (非致命錯誤) 。
        E_COMPILE_WARNING // 編譯警告
        E_USER_WARNING    // 用戶產生的警告信息

    Notice Error:通知錯誤(僅給出通知信息,腳本不終止運行)
        E_NOTICE      // 運行時通知。表示腳本遇到可能會表現為錯誤的情況.
        E_USER_NOTICE // 用戶產生的通知信息。

由此可知有5類是產生ERROR級別的錯誤,這種錯誤直接導致PHP程序退出。
可以定義成:

1 ERROR = E_ERROR | E_CORE_ERROR |  E_COMPILE_ERROR | E_USER_ERROR | E_PARSE

三、PHP異常處理中的黑科技

前面提到框架中是可以捕獲所有的錯誤和異常的,之所以能實現應該是使用瞭黑科技,哈哈!其實也不是什麼黑科技,主要是三個重要的函數:

1:set_error_handler()

看到這個名字估計就知道什麼意思瞭,這個函數用於捕獲錯誤,設置一個用戶自定義的錯誤處理函數。

<?php
    set_error_handler('zyferror');
    function zyferror($type, $message, $file, $line)
    {
      var_dump('<b>set_error_handler: ' . $type . ':' . $message . ' in ' . $file . ' on ' . $line . ' line .</b><br />');
    }
?>

當程序出現錯誤的時候自動調用此方法,不過需要註意一下兩點:第一,如果存在該方法,相應的error_reporting()就不能在使用瞭。所有的錯誤都會交給自定義的函數處理。第二,此方法不能處理以下級別的錯誤:E_ERROR、 E_PARSE、 E_CORE_ERROR、 E_CORE_WARNING、 E_COMPILE_ERROR、 E_COMPILE_WARNING,set_error_handler() 函數所在文件中產生的E_STRICT,該函數隻能捕獲系統產生的一些Warning、Notice級別的錯誤。
並且他有多種調用的方法:

<?php
     // 直接傳函數名 NonClassFunction
     set_error_handler('function_name');

     // 傳 class_name && function_name
     set_error_handler(array('class_name', 'function_name'));
?>

2:register_shutdown_function()

捕獲PHP的錯誤:Fatal Error、Parse Error等,這個方法是PHP腳本執行結束前最後一個調用的函數,比如腳本錯誤、die()、exit、異常、正常結束都會調用,多麼牛逼的一個函數啊!通過這個函數就可以在腳本結束前判斷這次執行是否有錯誤產生,這時就要借助於一個函數:error_get_last();這個函數可以拿到本次執行產生的所有錯誤。error_get_last();返回的信息:
[type] – 錯誤類型
[message] – 錯誤消息
[file] – 發生錯誤所在的文件
[line] – 發生錯誤所在的行

<?php
    register_shutdown_function('zyfshutdownfunc');
    function zyfshutdownfunc()
    {
        if ($error = error_get_last()) {
            var_dump('<b>register_shutdown_function: Type:' . $error['type'] . ' Msg: ' . $error['message'] . ' in ' . $error['file'] . ' on line ' . $error['line'] . '</b>');
        }
    }
?>

通過這種方法就可以巧妙的打印出程序結束前所有的錯誤信息。但是我在測試的時候我發現並不是所有的錯誤終止後都會調用這個函數,可以看下面的一個測試文件,內容是:

<?php
    register_shutdown_function('zyfshutdownfunc');
    function zyfshutdownfunc()
    {
        if ($error = error_get_last()) {
            var_dump('<b>register_shutdown_function: Type:' . $error['type'] . ' Msg: ' . $error['message'] . ' in ' . $error['file'] . ' on line ' . $error['line'] . '</b>');
        }
    }
    var_dump(23+-+); //此處語法錯誤
?>

自己可以試一下,你可以看到根本就不會觸發zyfshutdownfunc()函數,其實這是一個語法錯誤,直接報瞭一個:

<?php
    Parse error: syntax error, unexpected ')' in /www/mytest/exception/try-catch.php on line 71
?>

由此引出一個奇葩的問題:問什麼不能觸發,為什麼框架中是可以的?其實原因很簡單,隻在parse-time出錯時是不會調用本函數的。隻有在run-time出錯的時候,才會調用本函數,我的理解是語法檢查器前沒有執行register_shutdown_function()去把需要註冊的函數放到調用的堆棧中,所以就根本不會運行。那框架中為什麼任何錯誤都能進入到register_shutdown_function()中呢,其實在框架中一般會有統一的入口index.php,然後每個類庫文件都會通過include ** 的方式加載到index.php中,相當與所有的程序都會在index.php中聚集,同樣,你寫的具有語法錯誤的文件也會被引入到入口文件中,這樣的話,調用框架,執行index.php,index.php本身並沒有語法錯誤,也就不會產生parse-time錯誤,而是 include 文件出錯瞭,是run-time的時候出錯瞭,所以框架執行完之後就會觸發register_shutdown_function();
所以現在可是試一下這個寫法,這樣就會觸發zyfshutdownfunc()回調瞭:

a.php文件
<?php
  // 模擬語法錯誤
  var_dump(23+-+);
?>

b.php文件
<?php
    register_shutdown_function('zyfshutdownfunc');
    function zyfshutdownfunc()
    {
        if ($error = error_get_last()) {
            var_dump('<b>register_shutdown_function: Type:' . $error['type'] . ' Msg: ' . $error['message'] . ' in ' . $error['file'] . ' on line ' . $error['line'] . '</b>');
        }
    }
    require 'a.php';
?>

3:set_exception_handler()

設置默認的異常處理程序,用在沒有用try/catch塊來捕獲的異常,也就是說不管你拋出的異常有沒有人捕獲,如果沒有人捕獲就會進入到該方法中,並且在回調函數調用後異常會中止。看一下用法:

<?php
    set_exception_handler('zyfexception');
    function zyfexception($exception)
    {
        var_dump("<b>set_exception_handler: Exception: " . $exception->getMessage()  . '</b>');
    }
    throw new Exception("zyf exception");
?>

四、巧妙的捕獲錯誤和異常

1:把錯誤以異常的形式拋出(不能完全拋出)

由上面的講解我們知道,php中的錯誤是不能以異常的像是捕獲的,但是我們需要讓他們拋出,已達到擴展 try-catch的影響范圍,我們前面講到過set_error_handler() 方法,他是幹嘛用的,他是捕獲錯誤的,所以我們就可以借助他來吧錯誤捕獲,然後再以異常的形式拋出,ok,試試下面的寫法:

<?php
    set_error_handler('zyferror');
    function zyferror($type, $message, $file, $line)
    {
        throw new \Exception($message . 'zyf錯誤當做異常');
    }

    $num = 0;
    try {
        echo 1/$num;

    } catch (Exception $e){
        echo $e->getMessage();
    }
?>

好瞭,試一下,會打印出:

Division by zero zyf123

流程:本來是除0錯誤,然後觸發set_error_handler(),在set_error_handler()中相當與殺瞭個回馬槍,再把錯誤信息以異常的形式拋出來,這樣就可以實現錯誤以異常的形式拋出。大傢要註意:這樣做是有缺點的,會受到set_error_handler()函數捕獲級別的限制。

2:捕獲所有的錯誤

由set_error_handler()可知,他能夠捕獲一部分錯誤,不能捕獲系統級E_ERROR、E_PARSE等錯誤,但是這部分可以由register_shutdown_function()捕獲。所以兩者結合能出現很好的功能。
看下面的程序:

a.php內容:
<?
    // 模擬Fatal error錯誤
    //test();

    // 模擬用戶產生ERROR錯誤
    //trigger_error('zyf-error', E_USER_ERROR);

    // 模擬語法錯誤
    var_dump(23+-+);

    // 模擬Notice錯誤
    //echo $f;

    // 模擬Warning錯誤
    //echo '123';
    //ob_flush();
    //flush();
    //header("Content-type:text/html;charset=gb2312");
?>
b.php內容:
<?
    error_reporting(0);
    register_shutdown_function('zyfshutdownfunc');
    function zyfshutdownfunc()
    {
        if ($error = error_get_last()) {
            var_dump('<b>register_shutdown_function: Type:' . $error['type'] . ' Msg: ' . $error['message'] . ' in ' . $error['file'] . ' on line ' . $error['line'] . '</b>');
        }
    }

    set_error_handler('zyferror');
    function zyferror($type, $message, $file, $line)
    {
        var_dump('<b>set_error_handler: ' . $type . ':' . $message . ' in ' . $file . ' on ' . $line . ' line .</b><br />');
    }

    require 'a.php';
?>

到此就可以解釋開頭的那個程序瞭吧,test.php 如果是單文件執行是不能捕獲到錯誤的,如果你在框架中執行就是可以的,當然你按照我上面介紹的來擴展也是可以的。

五、自定義異常處理和異常嵌套

1:自定義異常處理

  在復雜的系統中,我們往往需要自己捕獲我們需要特殊處理的異常,這些異常可能是特殊情況下拋出的。所以我們就自己定義一個異常捕獲類,該類必須是 exception 類的一個擴展,該類繼承瞭 PHP 的 exception 類的所有屬性,並且我們可以添加自定義的函數,使用的時候其實和之前的一樣,大致寫法如下:

<?php
    class zyfException extends Exception
    {
        public function errorzyfMessage()
        {
            return 'Error line ' . $this->getLine().' in ' . $this->getFile()
                .': <b>' . $this->getMessage() . '</b> Must in (0 - 60)';
        }
    }

    $age = 10;
    try {
        $age = intval($age);
        if($age > 60) {
            throw new zyfException($age);
        }

    } catch (zyfException $e) {
        echo $e->errorzyfMessage();

    }
?>

2:異常嵌套

異常嵌套是比較常見的寫法,在自定義的異常處理中,try 塊中可以定義多個異常捕獲,然後分層傳遞異常,理解和冒泡差不多,看下面的實現:

<?php
    $age = 10;
    try {
        $age = intval($age);
        if($age > 60) {
            throw new zyfException($age);
        }

        if ($age <= 0) {
            throw new Exception($age . ' must > 0');
        }

    } catch (zyfException $e) {
        echo $e->errorzyfMessage();

    } catch(Exception $e) {
        echo $e->getMessage();
    }
?>

當然也可以在catch中再拋出異常給上層:

<?php
    $age = 100;
    try {
        try {
            $age = intval($age);
            if($age > 60) {
                throw new Exception($age);
            }

        } catch (Exception $e) {
            throw new zyfException($age);

        }

    } catch (zyfException $e) {
        echo $e->errorzyfMessage();
    }
?>

六、PHP7中的異常處理

現在寫PHP必須考慮版本情況,上面的寫法在PHP7中大部分都能實現,但是也會有不同點,在PHP7更新中有一條:更多的Error變為可捕獲的Exception,現在的PHP7實現瞭一個全局的throwable接口,原來老的Exception和其中一部分Error實現瞭這個接口(interface),PHP7中更多的Error變為可捕獲的Exception返回給捕捉器,這樣其實和前面提到的擴展try-catch影響范圍一樣,但是如果不捕獲則還是按照Error對待,看下面兩個:

<?php
    try {
        test();

    } catch(Throwable $e) {
        echo $e->getMessage() . ' zyf';
    }

    try {
        test();

    } catch(Error $e) {
        echo $e->getMessage() . ' zyf';
    }
?>

因為PHP7實現瞭throwable接口,那麼就可以使用第一個這種方式來捕獲異常。又因為部分Error實現瞭接口,並且更多的Error變為可捕獲的Exception,那麼就可以使用第二種方式來捕獲異常。下面是在網上找的PHP7的異常層次樹:
Throwable
Exception 異常

Error 錯誤
ArithmeticError 算數錯誤
DivisionByZeroError 除數為0的錯誤
AssertionError 聲明錯誤
ParseError 解析錯誤
TypeError 類型錯誤

關於錯誤和異常處理的大致就寫這麼多,多謝大傢。

以上就是再談PHP錯誤與異常處理的詳細內容,更多關於PHP錯誤與異常處理的資料請關註WalkonNet其它相關文章!